--Ctrl+M
--select * from orderheader where ord_showcons = 'ABDredlkjf'


SELECT TOP 10
  CAST(user_seeks * avg_total_user_cost * (avg_user_impact * 0.01) AS INT) AS [index_advantage]
, migs.last_user_seek
, mid.[statement] AS [Database.Schema.Table]
, mid.equality_columns
, mid.inequality_columns
, mid.included_columns
, migs.unique_compiles
, migs.user_seeks
, migs.avg_total_user_cost
, migs.avg_user_impact
, 'CREATE INDEX IX_' + LEFT(RIGHT(mid.STATEMENT, CHARINDEX('[',REVERSE(mid.[statement]))-1), LEN(RIGHT(mid.STATEMENT, CHARINDEX('[',REVERSE(mid.[statement]))-1))-1) + '_' +
  CASE WHEN mid.inequality_columns IS NULL THEN REPLACE(REPLACE(REPLACE(mid.equality_columns, ', ', '_'), '[',''), ']','')
         WHEN mid.equality_columns IS NULL THEN REPLACE(REPLACE(REPLACE(mid.inequality_columns, ', ', '_'), '[',''), ']','')
         ELSE REPLACE(REPLACE(REPLACE(mid.equality_columns, ', ', '_'), '[',''), ']','') + '_' + REPLACE(REPLACE(REPLACE(mid.inequality_columns, ', ', '_'), '[',''), ']','') END +
  '_Custom ON ' + mid.STATEMENT + ' (' + 
    CASE WHEN mid.inequality_columns IS NULL THEN mid.equality_columns
         WHEN mid.equality_columns IS NULL THEN mid.inequality_columns
         ELSE mid.equality_columns + ', ' + mid.inequality_columns END + ')' +
    CASE WHEN ISNULL(mid.included_columns, '') <> '' AND LEN(ISNULL(mid.included_columns, '')) - LEN(REPLACE(ISNULL(mid.included_columns, ''), ',', '')) + 1 < 4 THEN ' INCLUDE (' + mid.included_columns + ')' ELSE '' END      
FROM sys.dm_db_missing_index_group_stats AS migs WITH (NOLOCK)
INNER JOIN sys.dm_db_missing_index_groups AS mig WITH (NOLOCK)ON migs.group_handle = mig.index_group_handle
INNER JOIN sys.dm_db_missing_index_details AS mid WITH (NOLOCK) ON mig.index_handle = mid.index_handle
WHERE mid.database_id = DB_ID()
ORDER BY index_advantage DESC;

select ord_hdrnumber from orderheader where ord_consignee = 'ABDredlkjf'

SELECT 
  c.name
, b.name
, a.* 
FROM 
  sys.dm_db_index_usage_stats a
    INNER JOIN
  sys.indexes b ON a.object_id = b.object_id AND a.index_id = b.index_id
    INNER JOIN
  sys.tables c ON a.object_id = c.object_id
WHERE
  a.database_id = db_id()
    AND
  c.name = 'orderheader'

SELECT TOP 10 
  OBJECT_NAME(s.[object_id]) AS [Table Name]
, i.name AS [Index Name]
, user_updates AS [Total Writes]
, user_seeks + user_scans + user_lookups AS [Total Reads]
, user_updates - (user_seeks + user_scans + user_lookups) AS [Difference]
FROM 
  sys.dm_db_index_usage_stats AS s WITH (NOLOCK)
    INNER JOIN 
  sys.indexes AS i WITH (NOLOCK) ON s.[object_id] = i.[object_id] AND i.index_id = s.index_id
WHERE 
  OBJECTPROPERTY(s.[object_id],'IsUserTable') = 1
	  AND 
  s.database_id = DB_ID()
	  AND 
  user_updates > (user_seeks + user_scans + user_lookups)
    AND
  user_seeks + user_scans + user_lookups < 10
	  AND 
  i.index_id > 1
    AND
  i.is_primary_key = 0
ORDER BY 
  [Difference] DESC
, [Total Writes] DESC
, [Total Reads] ASC;


SELECT 
  tbl.name AS TableName
, ind.name AS IndexName
, indexstats.index_type_desc AS IndexType
, indexstats.avg_fragmentation_in_percent
, CASE WHEN avg_fragmentation_in_percent >= 30 THEN 'REBUILD'
       WHEN avg_fragmentation_in_percent >= 10 THEN 'REORGANIZE'
       ELSE 'NO ACTION NEEDED'
  END AS DesiredAction
FROM 
  sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL) indexstats 
    INNER JOIN 
  sys.indexes ind ON ind.object_id = indexstats.object_id AND ind.index_id = indexstats.index_id 
    INNER JOIN
  sys.tables tbl ON ind.object_id = tbl.object_id
ORDER BY indexstats.avg_fragmentation_in_percent DESC


--Company name statistics
SELECT STATS_DATE(453576654, 4)
--Stop arrival date statistics
SELECT STATS_DATE(898102240, 4)
